//=============================================================================
// CBPAugLight. Rebuild with ScriptRays.
//=============================================================================
class CBPAugLight extends AugLight;

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var FunnyName43 FunnyName402;
var FunnyName43 FunnyName403;

//-----------------------------------------------------------------------------
// Network replication.
//-----------------------------------------------------------------------------

replication
{
	reliable if ( bNetOwner && int(Role)==int(ENetRole.ROLE_Authority) )
		FunnyName402, FunnyName403;
}

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

final function FunnyName26()
{
	if ( FunnyName402!=None )
	{
		FunnyName402.Destroy();
	}
	if ( FunnyName403!=None )
	{
		FunnyName403.Destroy();
	}
	FunnyName402 = None;
	FunnyName403 = None;
}

function PreTravel()
{
	FunnyName26();
}

function Deactivate()
{
	Super(Augmentation).Deactivate();
	FunnyName26();
}

simulated final function FunnyName25()
{
	local vector FunnyName278, FunnyName192, FunnyName276, FunnyName279;

	if ( FunnyName402!=None && Player!=None )
	{
		FunnyName276 = Player.Location;
		FunnyName276.Z += Player.BaseEyeHeight;
		FunnyName279 = FunnyName276+LevelValues[CurrentLevel]*Vector(Player.ViewRotation);
		Trace( FunnyName192, FunnyName278, FunnyName279, FunnyName276, true );
		if ( FunnyName192==vect(0.0,0.0,0.0) )
		{
			FunnyName192 = FunnyName279;
		}
		FunnyName402.SetLocation( FunnyName192-Vector(Player.ViewRotation)*float(64) );
		FunnyName402.LightRadius = byte(FClamp(VSize(FunnyName192-FunnyName276)/LevelValues[CurrentLevel],0.0,1.0)*5.12+4.0);
		FunnyName402.LightType = LT_Steady;
	}
}

simulated final function FunnyName24()
{
	if ( FunnyName403!=None && Player!=None )
	{
		FunnyName403.SetLocation( Player.Location+vect(0.0,0.0,1.0)*Player.BaseEyeHeight+vect(1.0,1.0,0.0)*Vector(Player.Rotation)*Player.CollisionRadius*1.5 );
	}
}

//-----------------------------------------------------------------------------
// state Active.
//-----------------------------------------------------------------------------

simulated state Active
{
	simulated function Tick( float FunnyName200 )
	{
		if ( !bIsActive && int(Role)<int(ENetRole.ROLE_Authority) )
		{
			GotoState( 'Inactive' );
		}
		else
		{
			FunnyName25();
			FunnyName24();
		}
	}

	function BeginState()
	{
		Super(Object).BeginState();
		FunnyName402 = Spawn( Class'FunnyName43', Player, '', Player.Location );
		if ( FunnyName402!=None )
		{
			AIStartEvent( 'Beam', EAITYPE_Visual );
			FunnyName25();
		}
		FunnyName403 = Spawn( Class'FunnyName43', Player, '', Player.Location );
		if ( FunnyName403!=None )
		{
			FunnyName403.LightBrightness = 220;
			FunnyName24();
		}
	}
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 RemoteRole=ROLE_SimulatedProxy
}
