//=============================================================================
// CBPHUDObjectSlot. Rebuild with ScriptRays.
//=============================================================================
class CBPHUDObjectSlot extends HUDObjectSlot;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

function UpdateItemText()
{
	local DeusExWeapon FunnyName330;

	itemText = "";
	if ( Item==None )
	{
		return;
	}
	FunnyName330 = DeusExWeapon(Item);
	if ( FunnyName330!=None && FunnyName330.AmmoType!=None )
	{
		if ( FunnyName330.IsA('WeaponNanoVirusGrenade') || FunnyName330.IsA('WeaponGasGrenade') || FunnyName330.IsA('WeaponEMPGrenade') || FunnyName330.IsA('WeaponLAM') )
		{
			if ( FunnyName330.AmmoType.AmmoAmount>1 )
			{
				itemText = CountLabel @ string(FunnyName330.AmmoType.AmmoAmount);
			}
		}
		else if ( FunnyName330.AmmoName!=Class'AmmoNone' && !FunnyName330.bHandToHand && int(FunnyName330.ReloadCount)!=0 )
		{
			itemText = FunnyName330.AmmoType.beltDescription;
		}
	}
	else if ( Item.IsA('DeusExPickup') && !Item.IsA('NanoKeyRing') && DeusExPickup(Item).NumCopies>1 )
	{
		itemText = DeusExPickup(Item).CountLabel @ string(DeusExPickup(Item).NumCopies);
	}
}

function DrawHUDIcon( GC GC )
{
	if ( Item!=None && Item.Icon!=None )
	{
		GC.SetStyle( DSTY_Masked );
		GC.SetTileColorRGB( 255, 255, 255 );
		GC.DrawTexture( float(slotIconX), float(slotIconY), float(slotFillWidth), float(slotFillHeight), 0.0, 0.0, Item.Icon );
	}
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
}
