//=============================================================================
// CBPMenuScreenCustomizeKeys. Rebuild with ScriptRays.
//=============================================================================
class CBPMenuScreenCustomizeKeys extends MenuScreenCustomizeKeys;

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var string FunnyName505[65];
var string FunnyName506[65];
var localized string Functions2[4];
var string Aliases2[4];

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

function BuildKeyBindings()
{
	local int FunnyName214, j, pos, FunnyName507;
	local string KeyName, Alias;

	FunnyName507 = 61;
	for ( FunnyName214=0; FunnyName214<65; FunnyName214++ )
	{
		FunnyName505[FunnyName214] = "";
		FunnyName506[FunnyName214] = "";
	}
	for ( FunnyName214=0; FunnyName214<255; FunnyName214++ )
	{
		KeyName = Player.ConsoleCommand( "KEYNAME"@string(FunnyName214) );
		if ( KeyName!="" )
		{
			Alias = Player.ConsoleCommand( "KEYBINDING"@KeyName );
			if ( Alias!="" )
			{
				pos = InStr( Alias, " " );
				if ( pos!=-1 )
				{
					Alias = Left( Alias, pos );
				}
				for ( j=0; j<4+FunnyName507; j++ )
				{
					if ( j<FunnyName507 && AliasNames[j]~=Alias || j>=FunnyName507 && Aliases2[j-FunnyName507]~=Alias )
					{
						if ( FunnyName505[j]=="" )
						{
							FunnyName505[j] = GetKeyDisplayNameFromKeyName( KeyName );
						}
						else if ( FunnyName506[j]=="" )
						{
							FunnyName506[j] = GetKeyDisplayNameFromKeyName( KeyName );
						}
					}
				}
			}
		}
	}
}

function ProcessKeySelection( int KeyNo, string KeyName, string keyDisplayName )
{
	local int FunnyName214;
	local string FunnyName147;

	if ( KeyName=="" || KeyName~="Escape" || KeyNo>=112 && KeyNo<=129 || KeyNo>=48 && KeyNo<=57 || KeyName~="Tilde" || KeyName~="PrintScrn" || KeyName~="Pause" )
	{
		return;
	}
	if ( FunnyName505[Selection]==keyDisplayName || FunnyName506[Selection]==keyDisplayName )
	{
		return;
	}
	for ( FunnyName214=0; FunnyName214<61+4; FunnyName214++ )
	{
		if ( FunnyName214<61 )
		{
			FunnyName147 = FunctionText[FunnyName214];
		}
		else
		{
			FunnyName147 = Functions2[FunnyName214-61];
		}
		if ( FunnyName506[FunnyName214]==keyDisplayName )
		{
			ShowHelp( Sprintf(ReassignedFromLabel,keyDisplayName,FunnyName147) );
			AddPending( GetKeyFromDisplayName(FunnyName506[FunnyName214]) );
			FunnyName506[FunnyName214] = "";
		}
		if ( FunnyName505[FunnyName214]==keyDisplayName )
		{
			ShowHelp( Sprintf(ReassignedFromLabel,keyDisplayName,FunnyName147) );
			AddPending( GetKeyFromDisplayName(FunnyName505[FunnyName214]) );
			FunnyName505[FunnyName214] = FunnyName506[FunnyName214];
			FunnyName506[FunnyName214] = "";
		}
	}
	if ( FunnyName505[Selection]=="" )
	{
		FunnyName505[Selection] = keyDisplayName;
	}
	else if ( FunnyName506[Selection]=="" )
	{
		FunnyName506[Selection] = keyDisplayName;
	}
	else if ( CanRemapKey(FunnyName505[Selection]) )
	{
		AddPending( GetKeyFromDisplayName(FunnyName505[Selection]) );
		FunnyName505[Selection] = FunnyName506[Selection];
		FunnyName506[Selection] = keyDisplayName;
	}
	else if ( CanRemapKey(FunnyName506[Selection]) )
	{
		AddPending( GetKeyFromDisplayName(FunnyName506[Selection]) );
		FunnyName506[Selection] = keyDisplayName;
	}
	if ( Selection<61 )
	{
		FunnyName147 = AliasNames[Selection];
	}
	else
	{
		FunnyName147 = Aliases2[Selection-61];
	}
	AddPending( KeyName@FunnyName147 );
	RefreshKeyBindings();
}

function PopulateKeyList()
{
	local int FunnyName214;

	lstKeys.DeleteAllRows();
	for ( FunnyName214=0; FunnyName214<61; FunnyName214++ )
	{
		lstKeys.AddRow( FunctionText[FunnyName214]$";"$GetInputDisplayText(FunnyName214) );
	}
	for ( FunnyName214=0; FunnyName214<4; FunnyName214++ )
	{
		lstKeys.AddRow( Functions2[FunnyName214]$";"$GetInputDisplayText(FunnyName214+61) );
	}
}

function string GetInputDisplayText( int FunnyName214 )
{
	if ( FunnyName505[FunnyName214]=="" )
	{
		return NoneText;
	}
	else if ( FunnyName506[FunnyName214]!="" )
	{
		return FunnyName505[FunnyName214] $ "," @ FunnyName506[FunnyName214];
	}
	else
	{
		return FunnyName505[FunnyName214];
	}
}

function RefreshKeyBindings()
{
	local int FunnyName214;

	for ( FunnyName214=0; FunnyName214<61+4; FunnyName214++ )
	{
		lstKeys.SetField( lstKeys.IndexToRowId(FunnyName214), 1, GetInputDisplayText(FunnyName214) );
	}
}

function ClearFunction()
{
	local int FunnyName508, rowIndex;

	FunnyName508 = lstKeys.GetSelectedRow();
	if ( FunnyName508!=0 )
	{
		rowIndex = lstKeys.RowIdToIndex( FunnyName508 );
		if ( FunnyName506[rowIndex]!="" && CanRemapKey(FunnyName506[rowIndex]) )
		{
			AddPending( GetKeyFromDisplayName(FunnyName506[rowIndex]) );
			FunnyName506[rowIndex] = "";
		}
		if ( FunnyName505[rowIndex]!="" && CanRemapKey(FunnyName505[rowIndex]) )
		{
			AddPending( GetKeyFromDisplayName(FunnyName505[rowIndex]) );
			FunnyName505[rowIndex] = FunnyName506[rowIndex];
			FunnyName506[rowIndex] = "";
		}
		RefreshKeyBindings();
	}
}

function ProcessPending()
{
	local int FunnyName214;
	local FunnyName51 FunnyName146;

	if ( Pending>0 )
	{
		FunnyName146 = Player.Spawn( Class'FunnyName51' );
		for ( FunnyName214=0; FunnyName214<Pending; FunnyName214++ )
		{
			FunnyName146.ConsoleCommand( string('Set')@string('Input')@PendingCommands[FunnyName214] );
			FunnyName146.ConsoleCommand( string('Set')@string('InputExt')@PendingCommands[FunnyName214] );
		}
		FunnyName146.Destroy();
	}
	Pending = 0;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 Functions2(0)="Pretend To Be Dead"
 Functions2(1)="Suicide"
 Functions2(2)="Display The Console"
 Functions2(3)="Toggle BehindView"
 Aliases2(0)="FeignDeath"
 Aliases2(1)="Suicide"
 Aliases2(2)="Type"
 Aliases2(3)="ToggleBehindView"
}
