//=============================================================================
// MTLDeathMatch. Rebuild with ScriptRays.
//=============================================================================
class MTLDeathMatch extends DeathMatchGame;

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var MTLManager FunnyName345;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

event InitGame( string FunnyName346, out string FunnyName347 )
{
	Class'FunnyName53'.static.FunnyName56( Self, FunnyName346, FunnyName347 );
}

function PreBeginPlay()
{
	if ( int(Level.NetMode)!=int(ENetMode.NM_Standalone) )
	{
		if ( FunnyName345==None )
		{
			FunnyName345 = Spawn( Class'MTLManager' );
		}
		FunnyName345.FunnyName409 = Self;
	}
	Super.PreBeginPlay();
}

function PostBeginPlay()
{
	if ( int(Level.NetMode)!=int(ENetMode.NM_Standalone) )
	{
		FunnyName49(Level.SpawnNotify).FunnyName1();
	}
	Super.PostBeginPlay();
}

function bool ApproveClass( Class<PlayerPawn> FunnyName306 )
{
	return true;
}

function ScoreKill( Pawn FunnyName202, Pawn FunnyName348 )
{
}

function Killed( Pawn FunnyName202, Pawn FunnyName348, name FunnyName203 )
{
	Super.Killed( FunnyName202, FunnyName348, FunnyName203 );
	BaseMutator.ScoreKill( FunnyName202, FunnyName348 );
}

function ChangeOption( out string Options, string OptionKey, string FunnyName363 )
{
	local string NewOptions, CurOption, CurKey, CurValue;

	NewOptions = "";
	while ( GrabOption(Options,CurOption) )
	{
		GetKeyValue( CurOption, CurKey, CurValue );
		if ( CurKey~=OptionKey )
		{
			CurValue = FunnyName363;
		}
		NewOptions = NewOptions $ "?" $ CurKey $ "=" $ CurValue;
	}
	Options = NewOptions;
}

event PreLogin( string FunnyName346, string FunnyName349, out string FunnyName347, out string FunnyName350 )
{
	Super.PreLogin( FunnyName346, FunnyName349, FunnyName347, FunnyName350 );
	if ( FunnyName347=="" )
	{
	}
	if ( Len(FunnyName346)>800 || HasOption(FunnyName346,string('LoadGame')) )
	{
		FunnyName347 = "PreLogin Failed.";
	}
}

event PlayerPawn Login( string Portal, string FunnyName346, out string FunnyName347, Class<PlayerPawn> SpawnClass )
{
	local MTLPlayer FunnyName351;
	local string FunnyName364, FunnyName365;
	local int FunnyName366;

	if ( MaxPlayers>0 && NumPlayers>=MaxPlayers )
	{
		FunnyName347 = TooManyPlayers;
		return None;
	}
	SpawnClass = DefaultPlayerClass;
	FunnyName364 = ParseOption( FunnyName346, "Class" );
	FunnyName366 = InStr( FunnyName364, "." );
	if ( FunnyName366!=-1 )
	{
		FunnyName365 = mid( FunnyName364, FunnyName366+1 );
		FunnyName364 = Left( FunnyName364, FunnyName366 );
	}
	else
	{
		FunnyName365 = FunnyName364;
		FunnyName364 = "";
	}
	if ( FunnyName365~="MPNSF" || FunnyName365~="MTLNSF" )
	{
		SpawnClass = Class'MTLNSF';
	}
	else if ( FunnyName365~="MPUNATCO" || FunnyName365~="MTLUNATCO" )
	{
		SpawnClass = Class'MTLUNATCO';
	}
	else if ( FunnyName365~="MPMJ12" || FunnyName365~="MTLMJ12" )
	{
		SpawnClass = Class'MTLMJ12';
	}
	ChangeOption( FunnyName346, "Class", string(SpawnClass) );
	FunnyName351 = MTLPlayer(Super.Login(Portal,FunnyName346,FunnyName347,SpawnClass));
	if ( FunnyName351!=None )
	{
		FunnyName351.FunnyName83( FunnyName351.PlayerReplicationInfo.PlayerName );
	}
	return FunnyName351;
}

function SetupAbilities( DeusExPlayer FunnyName354 )
{
	local MTLPlayer FunnyName351;

	FunnyName351 = MTLPlayer(FunnyName354);
	if ( FunnyName351==None )
	{
		return;
	}
	if ( FunnyName351.FunnyName127 )
	{
		FunnyName351.FunnyName127 = false;
		return;
	}
	FunnyName351.SkillPointsAvail = SkillsAvail;
	FunnyName351.SkillPointsTotal = SkillsAvail;
	if ( bAugsAllowed )
	{
		GrantAugs( FunnyName351, InitialAugs );
	}
}

event PostLogin( PlayerPawn FunnyName355 )
{
	local MTLPlayer FunnyName351;

	FunnyName351 = MTLPlayer(FunnyName355);
	FunnyName351.FunnyName113 = Class'FunnyName53'.static.FunnyName90( FunnyName351 );
	FunnyName351.FunnyName112 = FunnyName345;
	if ( FunnyName351.bAdmin )
	{
		FunnyName351.PlayerReplicationInfo.bAdmin = true;
		Log( FunnyName351.FunnyName39(), 'AdminLogin' );
	}
	FunnyName345.FunnyName68( FunnyName351 );
	Super.PostLogin( FunnyName351 );
}

function Logout( Pawn FunnyName356 )
{
	Super.Logout( FunnyName356 );
	if ( FunnyName356.IsA('PlayerPawn') && !FunnyName356.IsA('Spectator') && PlayerPawn(FunnyName356).GameReplicationInfo==None )
	{
		NumPlayers++;
	}
}

function bool SetEndCams( string FunnyName367 )
{
	local Pawn FunnyName156, FunnyName368;

	GetWinningPlayer( FunnyName368 );
	for ( FunnyName156=Level.PawnList; FunnyName156!=None; FunnyName156=FunnyName156.nextPawn )
	{
		if ( FunnyName156.IsA('PlayerPawn') )
		{
			PlayerPawn(FunnyName156).bBehindView = true;
			PlayerPawn(FunnyName156).ViewTarget = FunnyName368;
		}
		FunnyName156.ClientGameEnded();
		FunnyName156.GotoState( 'GameEnded' );
	}
	return true;
}

simulated function RefreshScoreArray( DeusExPlayer FunnyName355 )
{
	local int i, FunnyName362;
	local PlayerReplicationInfo lpri;
	local PlayerPawn pp;

	if ( FunnyName355==None )
	{
		return;
	}
	pp = FunnyName355.GetPlayerPawn();
	if ( pp==None || pp.GameReplicationInfo==None )
	{
		return;
	}
	scorePlayers = 0;
	for ( i=0; i<32; i++ )
	{
		lpri = pp.GameReplicationInfo.PRIArray[i];
		if ( lpri!=None && (!lpri.bIsSpectator || lpri.bWaitingPlayer) )
		{
			scoreArray[scorePlayers].PlayerName = lpri.PlayerName;
			scoreArray[scorePlayers].Score = lpri.Score;
			scoreArray[scorePlayers].Deaths = lpri.Deaths;
			scoreArray[scorePlayers].Streak = lpri.Streak;
			scoreArray[scorePlayers].Team = int(lpri.Team);
			scoreArray[scorePlayers].PlayerID = lpri.PlayerID;
			scorePlayers++;
		}
	}
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 DefaultPlayerClass=Class'DXMTL152b1.MTLJCDenton'
 GameReplicationInfoClass=Class'DXMTL152b1.MTLGRI'
 NetPriority=10.000000
}
