//=============================================================================
// MTLTeam. Rebuild with ScriptRays.
//=============================================================================
class MTLTeam extends TeamDMGame;

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var Class<MTLPlayer> FunnyName32;
var Class<MTLPlayer> FunnyName31;
var MTLManager FunnyName345;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

event InitGame( string FunnyName346, out string FunnyName347 )
{
	Class'FunnyName53'.static.FunnyName56( Self, FunnyName346, FunnyName347 );
}

function PreBeginPlay()
{
	if ( int(Level.NetMode)!=int(ENetMode.NM_Standalone) )
	{
		if ( FunnyName345==None )
		{
			FunnyName345 = Spawn( Class'MTLManager' );
		}
		FunnyName345.FunnyName409 = Self;
	}
	Super.PreBeginPlay();
}

function PostBeginPlay()
{
	if ( int(Level.NetMode)!=int(ENetMode.NM_Standalone) )
	{
		FunnyName49(Level.SpawnNotify).FunnyName1();
	}
	Super.PostBeginPlay();
}

function bool ApproveClass( Class<PlayerPawn> FunnyName306 )
{
	return true;
}

function ScoreKill( Pawn FunnyName202, Pawn FunnyName348 )
{
}

function Killed( Pawn FunnyName202, Pawn FunnyName348, name FunnyName203 )
{
	Super.Killed( FunnyName202, FunnyName348, FunnyName203 );
	BaseMutator.ScoreKill( FunnyName202, FunnyName348 );
}

event PreLogin( string FunnyName346, string FunnyName349, out string FunnyName347, out string FunnyName350 )
{
	Super.PreLogin( FunnyName346, FunnyName349, FunnyName347, FunnyName350 );
	if ( FunnyName347=="" )
	{
	}
	if ( Len(FunnyName346)>800 || HasOption(FunnyName346,string('LoadGame')) )
	{
		FunnyName347 = "PreLogin Failed.";
	}
}

event PlayerPawn Login( string Portal, string FunnyName346, out string FunnyName347, Class<PlayerPawn> SpawnClass )
{
	local MTLPlayer FunnyName351;
	local int FunnyName352;
	local string FunnyName353;

	if ( MaxPlayers>0 && NumPlayers>=MaxPlayers )
	{
		FunnyName347 = TooManyPlayers;
		return None;
	}
	FunnyName352 = 128;
	if ( HasOption(FunnyName346,"Team") )
	{
		FunnyName353 = ParseOption( FunnyName346, "Team" );
		if ( FunnyName353!="" )
		{
			FunnyName352 = int(FunnyName353);
		}
	}
	if ( !ApproveTeam(FunnyName352) )
	{
		FunnyName352 = 128;
	}
	if ( FunnyName352==128 )
	{
		FunnyName352 = GetAutoTeam();
	}
	if ( FunnyName352==1 )
	{
		SpawnClass = FunnyName31;
	}
	else
	{
		SpawnClass = FunnyName32;
	}
	ChangeOption( FunnyName346, "Class", string(SpawnClass) );
	ChangeOption( FunnyName346, "Team", string(FunnyName352) );
	FunnyName351 = MTLPlayer(Super(DeusExMPGame).Login(Portal,FunnyName346,FunnyName347,SpawnClass));
	if ( FunnyName351!=None )
	{
		FunnyName351.FunnyName83( FunnyName351.PlayerReplicationInfo.PlayerName );
	}
	return FunnyName351;
}

function SetupAbilities( DeusExPlayer FunnyName354 )
{
	local MTLPlayer FunnyName351;

	FunnyName351 = MTLPlayer(FunnyName354);
	if ( FunnyName351==None )
	{
		return;
	}
	if ( FunnyName351.FunnyName127 )
	{
		FunnyName351.FunnyName127 = false;
		return;
	}
	FunnyName351.SkillPointsAvail = SkillsAvail;
	FunnyName351.SkillPointsTotal = SkillsAvail;
	if ( bAugsAllowed )
	{
		GrantAugs( FunnyName351, InitialAugs );
	}
}

event PostLogin( PlayerPawn FunnyName355 )
{
	local MTLPlayer FunnyName351;

	FunnyName351 = MTLPlayer(FunnyName355);
	FunnyName351.FunnyName113 = Class'FunnyName53'.static.FunnyName90( FunnyName351 );
	FunnyName351.FunnyName112 = FunnyName345;
	if ( FunnyName351.bAdmin )
	{
		FunnyName351.PlayerReplicationInfo.bAdmin = true;
		Log( FunnyName351.FunnyName39(), 'AdminLogin' );
	}
	FunnyName345.FunnyName68( FunnyName351 );
	Super.PostLogin( FunnyName351 );
}

function Logout( Pawn FunnyName356 )
{
	Super.Logout( FunnyName356 );
	if ( FunnyName356.IsA('PlayerPawn') && !FunnyName356.IsA('Spectator') && PlayerPawn(FunnyName356).GameReplicationInfo==None )
	{
		NumPlayers++;
	}
}

function SetTeam( DeusExPlayer FunnyName355 )
{
	if ( FunnyName355.IsA(FunnyName32.Name) )
	{
		FunnyName355.PlayerReplicationInfo.Team = 0;
		FunnyName355.MultiplayerNotifyMsg( FunnyName355.0 );
	}
	else if ( FunnyName355.IsA(FunnyName31.Name) )
	{
		FunnyName355.PlayerReplicationInfo.Team = 1;
		FunnyName355.MultiplayerNotifyMsg( FunnyName355.1 );
	}
	else
	{
		Log( "Warning: Player:"$string(FunnyName355)$" has chosen an invalid team!" );
	}
}

function bool ChangeTeam( Pawn FunnyName357, int NewTeam )
{
	local Class<MTLPlayer> FunnyName358;
	local MTLPlayer FunnyName359;

	if ( !ApproveTeam(NewTeam) )
	{
		NewTeam = 128;
	}
	if ( NewTeam==128 )
	{
		if ( PlayerPawn(FunnyName357)!=None )
		{
			NewTeam = int(PlayerPawn(FunnyName357).PlayerReplicationInfo.Team);
		}
		else
		{
			return false;
		}
	}
	if ( !Super(DeusExMPGame).ChangeTeam(FunnyName357,NewTeam) )
	{
		return false;
	}
	FunnyName359 = MTLPlayer(FunnyName357);
	if ( FunnyName359==None )
	{
		return false;
	}
	if ( NewTeam==0 )
	{
		FunnyName358 = FunnyName32;
	}
	else if ( NewTeam==1 )
	{
		FunnyName358 = FunnyName31;
	}
	else
	{
		return false;
	}
	return Class'FunnyName53'.static.FunnyName57( FunnyName359, FunnyName358 );
}

simulated function bool ArePlayersAllied( DeusExPlayer FunnyName360, DeusExPlayer FunnyName361 )
{
	if ( FunnyName360==None || FunnyName361==None || FunnyName360.PlayerReplicationInfo==None || FunnyName361.PlayerReplicationInfo==None )
	{
		return false;
	}
	return int(FunnyName360.PlayerReplicationInfo.Team)==int(FunnyName361.PlayerReplicationInfo.Team);
}

simulated function RefreshScoreArray( DeusExPlayer FunnyName355 )
{
	local int i, FunnyName362;
	local PlayerReplicationInfo lpri;
	local PlayerPawn pp;

	if ( FunnyName355==None )
	{
		return;
	}
	pp = FunnyName355.GetPlayerPawn();
	if ( pp==None || pp.GameReplicationInfo==None )
	{
		return;
	}
	scorePlayers = 0;
	for ( i=0; i<32; i++ )
	{
		lpri = pp.GameReplicationInfo.PRIArray[i];
		if ( lpri!=None && (!lpri.bIsSpectator || lpri.bWaitingPlayer) )
		{
			scoreArray[scorePlayers].PlayerName = lpri.PlayerName;
			scoreArray[scorePlayers].Score = lpri.Score;
			scoreArray[scorePlayers].Deaths = lpri.Deaths;
			scoreArray[scorePlayers].Streak = lpri.Streak;
			scoreArray[scorePlayers].Team = int(lpri.Team);
			scoreArray[scorePlayers].PlayerID = lpri.PlayerID;
			scorePlayers++;
		}
	}
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 FunnyName32=Class'DXMTL152b1.MTLUNATCO'
 FunnyName31=Class'DXMTL152b1.MTLNSF'
 DefaultPlayerClass=Class'DXMTL152b1.MTLUNATCO'
 GameReplicationInfoClass=Class'DXMTL152b1.MTLGRI'
 NetPriority=10.000000
}
