//=============================================================================
// DXWeaponSelector. Rebuild with ScriptRays.
//=============================================================================
class DXWeaponSelector extends Mutator
	config(Mutators);

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var byte FunnyName4;
var config bool b1AllowWeapons;
var config bool b1AllowAmmoCrates;
var config bool b1AllowTurrets;
var config bool b1AllowCameras;
var config bool b1AllowComputers;
var config bool b1AllowMedBots;
var config bool b1AllowRepairBots;
var config bool b1iLockPick;
var config bool b1iMultiTool;
var config bool b1iMedKit;
var config bool b1iBioCell;
var config bool bGepGun;
var config bool bFlameThrower;
var config bool bPlasmaRifle;
var config bool bAssaultGun;
var config bool bAssaultShotgun;
var config bool bSniperRifle;
var config bool bThrowingKnives;
var config bool bCombatKnife;
var config bool bNanoSword;
var config bool bRegularSword;
var config bool bCrossBow;
var config bool bSawedOffShotgun;
var config bool bPistol;
var config bool bStealthPistol;
var config bool bLAW;
var config bool bGasGrenade;
var config bool bEMPGrenade;
var config bool bLAM;
var config bool bNanoGrenade;
var config bool bPepperGun;
var config bool bBaton;
var config bool bCrowbar;
var config bool bProd;
var config bool bPS20;
var config bool b20mm;
var config bool bRocketWP;
var config bool bInitialized;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

function PostBeginPlay()
{
	Super.PostBeginPlay();
	if ( bInitialized )
	{
		SaveConfig();
		return;
	}
	FunnyName4 = 127;
	b1AllowWeapons = true;
	b1AllowAmmoCrates = true;
	b1AllowTurrets = true;
	b1AllowCameras = true;
	b1AllowComputers = true;
	b1AllowMedBots = true;
	b1AllowRepairBots = true;
	b1iLockPick = true;
	b1iMultiTool = true;
	b1iMedKit = true;
	b1iBioCell = true;
	bGepGun = true;
	bFlameThrower = true;
	bPlasmaRifle = true;
	bAssaultGun = true;
	bAssaultShotgun = true;
	bSniperRifle = true;
	bThrowingKnives = true;
	bCombatKnife = true;
	bNanoSword = true;
	bRegularSword = true;
	bCrossBow = true;
	bSawedOffShotgun = true;
	bPistol = true;
	bStealthPistol = true;
	bLAW = true;
	bGasGrenade = true;
	bEMPGrenade = true;
	bLAM = true;
	bNanoGrenade = true;
	bPepperGun = true;
	bBaton = true;
	bCrowbar = true;
	bProd = true;
	bPS20 = true;
	b20mm = true;
	bRocketWP = true;
	bInitialized = true;
	SaveConfig();
}

final function bool FunnyName3( Actor FunnyName7 )
{
	local bool r1;

	if ( FunnyName7.IsA('Weapon') )
	{
		if ( !b1AllowWeapons )
		{
			r1 = true;
		}
		else if ( FunnyName7.IsA('WeaponGEPGun') )
		{
			if ( !bGepGun )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponFlamethrower') )
		{
			if ( !bFlameThrower )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponPlasmaRifle') )
		{
			if ( !bPlasmaRifle )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponAssaultGun') )
		{
			if ( !bAssaultGun )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponAssaultShotgun') )
		{
			if ( !bAssaultShotgun )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponRifle') )
		{
			if ( !bSniperRifle )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponShuriken') )
		{
			if ( !bThrowingKnives )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponCombatKnife') )
		{
			if ( !bCombatKnife )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponNanoSword') )
		{
			if ( !bNanoSword )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponSword') )
		{
			if ( !bRegularSword )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponMiniCrossbow') )
		{
			if ( !bCrossBow )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponSawedOffShotgun') )
		{
			if ( !bSawedOffShotgun )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponPistol') )
		{
			if ( !bPistol )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponStealthPistol') )
		{
			if ( !bStealthPistol )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponLAW') )
		{
			if ( !bLAW )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponGasGrenade') )
		{
			if ( !bGasGrenade )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponEMPGrenade') )
		{
			if ( !bEMPGrenade )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponLAM') )
		{
			if ( !bLAM )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponNanoVirusGrenade') )
		{
			if ( !bNanoGrenade )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponPepperGun') )
		{
			if ( !bPepperGun )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponBaton') )
		{
			if ( !bBaton )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponCrowbar') )
		{
			if ( !bCrowbar )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponProd') )
		{
			if ( !bProd )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('WeaponHideAGun') )
		{
			if ( !bPS20 )
			{
				r1 = true;
			}
		}
	}
	else if ( FunnyName7.IsA('Ammo') )
	{
		if ( FunnyName7.IsA('Ammo20mm') )
		{
			if ( !b20mm )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('AmmoRocketWP') )
		{
			if ( !bRocketWP )
			{
				r1 = true;
			}
		}
	}
	else if ( FunnyName7.IsA('ammocrate') )
	{
		if ( !b1AllowAmmoCrates )
		{
			r1 = true;
		}
	}
	else if ( FunnyName7.IsA('DeusExDecoration') )
	{
		if ( FunnyName7.IsA('AutoTurret') )
		{
			if ( !b1AllowTurrets )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('AutoTurretGun') )
		{
			if ( !b1AllowTurrets )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('SecurityCamera') )
		{
			if ( !b1AllowCameras )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('ComputerSecurity') )
		{
			if ( !b1AllowComputers )
			{
				r1 = true;
			}
		}
	}
	else if ( FunnyName7.IsA('DeusExPickup') )
	{
		if ( FunnyName7.IsA('Lockpick') )
		{
			if ( !b1iLockPick )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('Multitool') )
		{
			if ( !b1iMultiTool )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('MedKit') )
		{
			if ( !b1iMedKit )
			{
				r1 = true;
			}
		}
		else if ( FunnyName7.IsA('BioelectricCell') )
		{
			if ( !b1iBioCell )
			{
				r1 = true;
			}
		}
	}
	else if ( FunnyName7.IsA('Robot') )
	{
		if ( FunnyName7.IsA('MedicalBot') )
		{
			if ( !b1AllowMedBots )
			{
				r1 = true;
				MedicalBot(FunnyName7).healAmount = 0;
			}
		}
		else if ( FunnyName7.IsA('RepairBot') )
		{
			if ( !b1AllowRepairBots )
			{
				r1 = true;
				RepairBot(FunnyName7).chargeAmount = 0;
				RepairBot(FunnyName7).mpChargeAmount = 0;
			}
		}
		if ( r1 )
		{
			Robot(FunnyName7).GotoState( 'Disabled' );
		}
	}
	if ( r1 )
	{
		FunnyName7.DrawType = DT_None;
		FunnyName7.DrawScale = 0.0;
		FunnyName7.AmbientSound = None;
		FunnyName7.bHidden = true;
		FunnyName7.SetCollisionSize( 0.0, 0.0 );
		FunnyName7.SetCollision( false, false, false );
	}
	return !r1;
}

function bool CheckReplacement( Actor FunnyName7, out byte FunnyName12 )
{
	return FunnyName3( FunnyName7 );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 FunnyName4=255
 b1AllowWeapons=True
 b1AllowAmmoCrates=True
 b1AllowTurrets=True
 b1AllowCameras=True
 b1AllowComputers=True
 b1AllowMedBots=True
 b1AllowRepairBots=True
 b1iLockPick=True
 b1iMultiTool=True
 b1iMedKit=True
 b1iBioCell=True
 bGepGun=True
 bFlameThrower=True
 bPlasmaRifle=True
 bAssaultGun=True
 bAssaultShotgun=True
 bSniperRifle=True
 bThrowingKnives=True
 bCombatKnife=True
 bNanoSword=True
 bRegularSword=True
 bCrossBow=True
 bSawedOffShotgun=True
 bPistol=True
 bStealthPistol=True
 bLAW=True
 bGasGrenade=True
 bEMPGrenade=True
 bLAM=True
 bNanoGrenade=True
 bPepperGun=True
 bBaton=True
 bCrowbar=True
 bProd=True
 bPS20=True
 b20mm=True
 bRocketWP=True
 bInitialized=True
}
