//=============================================================================
// ModifyPlayerSettings. Rebuild with ScriptRays.
//=============================================================================
class ModifyPlayerSettings extends Mutator
	config(Mutators);

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var config float JumpScale;
var config float GroundSpeedScale;
var config float WaterSpeedScale;
var config float AirSpeedScale;
var config float AirControl;
var config float HitDamageScale;
var config bool bInitialized;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

function PostBeginPlay()
{
	Super.PostBeginPlay();
	if ( bInitialized )
	{
		JumpScale = FClamp( JumpScale, 0.1, 10.0 );
		GroundSpeedScale = FClamp( GroundSpeedScale, 0.1, 10.0 );
		WaterSpeedScale = FClamp( WaterSpeedScale, 0.1, 10.0 );
		AirSpeedScale = FClamp( AirSpeedScale, 0.1, 10.0 );
		AirControl = FClamp( AirControl, 0.0, 1.0 );
		HitDamageScale = FClamp( HitDamageScale, 0.0, 100.0 );
		SaveConfig();
		return;
	}
	JumpScale = 1.0;
	GroundSpeedScale = 1.0;
	WaterSpeedScale = 1.0;
	AirSpeedScale = 1.0;
	AirControl = 0.05;
	HitDamageScale = 1.0;
	bInitialized = true;
	SaveConfig();
}

function ModifyPlayer( Pawn FunnyName5 )
{
	if ( Human(FunnyName5)!=None )
	{
		FunnyName5.JumpZ = Class'Human'.default.JumpZ*JumpScale;
		FunnyName5.default.JumpZ = FunnyName5.JumpZ;
		FunnyName5.GroundSpeed = Class'Human'.default.mpGroundSpeed*GroundSpeedScale;
		Human(FunnyName5).mpGroundSpeed = FunnyName5.GroundSpeed;
		Human(FunnyName5).default.mpGroundSpeed = FunnyName5.GroundSpeed;
		Human(FunnyName5).UpdateAnimRate( -1.0 );
		FunnyName5.WaterSpeed = Class'Human'.default.mpWaterSpeed*WaterSpeedScale;
		Human(FunnyName5).mpWaterSpeed = FunnyName5.WaterSpeed;
		Human(FunnyName5).default.mpWaterSpeed = FunnyName5.WaterSpeed;
		FunnyName5.AirSpeed = FunnyName5.default.AirSpeed*AirSpeedScale;
		FunnyName5.AirControl = AirControl;
		Human(FunnyName5).MPDamageMult = HitDamageScale*Class<Human>(FunnyName5.Class).default.MPDamageMult;
	}
	Super.ModifyPlayer( FunnyName5 );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 JumpScale=1.000000
 GroundSpeedScale=1.000000
 WaterSpeedScale=1.000000
 AirSpeedScale=1.000000
 AirControl=0.050000
 HitDamageScale=1.000000
 bInitialized=True
}
