//=============================================================================
// ModifyZoneInfo. Rebuild with ScriptRays.
//=============================================================================
class ModifyZoneInfo extends Mutator
	config(Mutators);

//-----------------------------------------------------------------------------
// Properties.
//-----------------------------------------------------------------------------

var config float GravityValue;
var config bool bChangeNonStandardZones;
var config bool bGodModeZone;
var config float GroundFriction;
var config float FluidFriction;
var config bool bInitialized;

//-----------------------------------------------------------------------------
// Global Functions.
//-----------------------------------------------------------------------------

function PostBeginPlay()
{
	Super.PostBeginPlay();
	if ( bInitialized )
	{
		GravityValue = FClamp( GravityValue, -5000.0, 5000.0 );
		GroundFriction = FClamp( GroundFriction, 0.0, 50.0 );
		FluidFriction = FClamp( FluidFriction, 0.0, 20.0 );
		SaveConfig();
		return;
	}
	GravityValue = -950.0;
	bChangeNonStandardZones = true;
	bGodModeZone = false;
	GroundFriction = 8.0;
	FluidFriction = 1.2;
	bInitialized = true;
	SaveConfig();
}

function bool CheckReplacement( Actor FunnyName5, out byte FunnyName12 )
{
	local ZoneInfo FunnyName13;

	FunnyName13 = ZoneInfo(FunnyName5);
	if ( FunnyName13!=None )
	{
		FunnyName13.bNeutralZone = bGodModeZone;
		if ( bChangeNonStandardZones || FunnyName13.ZoneGroundFriction~=8.0 )
		{
			FunnyName13.ZoneGroundFriction = GroundFriction;
		}
		if ( bChangeNonStandardZones || FunnyName13.ZoneFluidFriction~=1.2 )
		{
			FunnyName13.ZoneFluidFriction = FluidFriction;
		}
		if ( bChangeNonStandardZones || FunnyName13.ZoneGravity.Z~=-950.0 )
		{
			FunnyName13.ZoneGravity.Z = GravityValue;
		}
	}
	return true;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

defaultproperties
{
 GravityValue=-950.000000
 bChangeNonStandardZones=True
 GroundFriction=8.000000
 FluidFriction=1.200000
 bInitialized=True
}
